"use strict";
cc._RF.push(module, 'f2bb43C7QlNm6EdUx25tgOJ', 'GameControl');
// Script/GameControl.js

'use strict';

// Learn cc.Class:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] http://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    // Game.js
    properties: {
        // this property quotes the PreFab resource of stars

        // the random scale of disappearing time for stars
        maxWaveDuration: 0,
        minWaveDuration: 0,
        // ground node for confirming the height of the generated star's position
        ground: {
            default: null,
            type: cc.Node
        },
        // player node for obtaining the jump height of the main character and controlling the movement switch of the main character
        avatar: {
            default: null,
            type: cc.Node
        }
    },

    onLoad: function onLoad() {
        // obtain the anchor point of ground level on the y axis
        this.groundY = this.ground.y + this.ground.height / 2; // this.ground.top may also work
        var ground = this.ground;
        //ground.getComponent('Avatar').avatarGround;

        // generate a new star
        //this.spawnNewWave();
    },

    spawnNewWave: function spawnNewWave() {
        // generate a new node in the scene with a preset template
        //var newWave = cc.instantiate(this.wave1Prefab);
        //var newWave2 = cc.instantiate(this.wave2Prefab);
        //var newWave3 = cc.instantiate(this.wave3Prefab);
        //var newWave4 = cc.instantiate(this.wave4Prefab);
        //var newWave5 = cc.instantiate(this.wave5Prefab);
        // put the newly added node under the Canvas node
        // this.node.addChild(newWave);
        // this.node.addChild(newWave2); 
        // this.node.addChild(newWave3); 
        // this.node.addChild(newWave4); 
        // this.node.addChild(newWave5);
        //var collision = this.avatar.getComponent('Avatar').collisionThing;
        //return collision;

        // Set move action (FIX THIS, ACCEL DOES NOT HOOK INTO AVATAR.JS, AND ROADWIDTH IS FROM THE EXAMPLE!)
        // var newObstacleAction = new cc.MoveBy(this.accel, cc.p(-this.roadWidth, 0));

        // Add this obstacle prefab to the obstacles Node
        //  this.obstacleNode.addChild(newWave);
        //  this.obstacleNode.runAction(newObstacleAction);
        //
        // set up a random position for the star
        /*     newWave.setPosition(this.getNewWavePosition());
             // deliver the concrete example of the Game component into the star component
             newWave.getComponent('Obstacles Lvl 1').game = this; */
    },

    //Randomly generate the wave in a new position (to be superseded by newer code)
    getNewWavePosition: function getNewWavePosition() {
        //rand is for random
        var randX = 0;
        // According to the position of the ground level and the main character's jump height, randomly obtain an anchor point of the star on the y axis
        var randY = this.groundY + cc.random0To1() * this.avatar.getComponent('Avatar').jumpHeight + 50;
        // according to the width of the screen, randomly obtain an anchor point of star on the x axis
        var maxX = this.node.width / 2;
        randX = cc.randomMinus1To1() * maxX;
        // return to the anchor point of the star [cc.p is for parameters such as height and width]
        return cc.p(randX, randY);
    }

    /* pauseGame: function () {
    	cc.director.game.pause();
    }
    */

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    /*  start () {
        }, */

    // update (dt) {},
});

cc._RF.pop();